// makeTable.cpp
//
// Generates lookup tables for Listing10-3.

#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>


int main(void)
{
	char buf[256];
	union
	{ 
		double f;
		unsigned long long u;
	} fHigh;
	
	long long unsigned mantissa = 0x0fFFffFFffFFff;
	
	printf
	( 
		"r64Tbl:\n"
		"\t.double 0.0\n"
	);
	for( long long unsigned exponent = 1; exponent < 0x7ff; ++exponent )
	{
		fHigh.u = (exponent << 52) | mantissa;
		sprintf( buf, "%23.16e", fHigh.f );
		int extraDigit = buf[18] != 'e';
		printf
		( 
			"\t.double 1e%c%s \t// %4llu: %e\n", 
			((buf[19+extraDigit] == '-') ? '+' : '-'), 
			buf+20+extraDigit, 
			exponent, 
			fHigh.f 
		);
	}
	
	
	printf
	( 
		"r64ExpTbl:\n"
		"\t.word 0\n"
	);
	for( long long unsigned exponent = 1; exponent < 0x7ff; ++exponent )
	{
		fHigh.u = (exponent << 52) | mantissa;
		sprintf( buf, "%23.16e", fHigh.f );
		int extraDigit = buf[18] != 'e';
		char sign = buf[19+extraDigit];
		int leadZero = buf[20+extraDigit] == '0';
		printf
		( 
			"\t.word 0%c%s\n", 
			sign,
			buf+20+extraDigit+leadZero 
		);
	}
	
}
